; File......: NOVPURGE.ASM
; Author....: David Minter
; CIS ID....: 76247,3475
; Date......: $Date:   17 Aug 1991 15:38:02  $
; Revision..: $Revision:   1.3  $
; Log file..: $Logfile:   E:/nanfor/src/novpurge.asv  $
;
;	This is an original work by David Minter and hereby placed into
;	the public domain.
;
; Modification history:
; ---------------------
;
; $Log:   E:/nanfor/src/novpurge.asv  $
;  
;     Rev 1.3   17 Aug 1991 15:38:02   GLENN
;  Don Caton fixed some spelling errors in the doc
;  
;     Rev 1.2   15 Aug 1991 23:07:54   GLENN
;  Forest Belt proofread/edited/cleaned up doc
;  
;     Rev 1.1   11 Apr 1991 23:50:56   GLENN
;  Librarian error!  I changed the function name on the author but 
;  didn't realize that .ASM functions _had_ to obey the 10-character 
;  limit.  ft_novpurge() is now really called ft_novpurg().  
;  
;     Rev 1.0   01 Apr 1991 01:03:36   GLENN
;  Nanforum Toolkit
;  


; $DOC$
; $FUNCNAME$ 
;    FT_NOVPURGE()
; $CATEGORY$
;    NetWare
; $ONELINER$
;    Purge all deleted files on a Novell server
; $SYNTAX$
;    FT_NOVPURGE() -> lTemp
; $ARGUMENTS$
;    None
; $RETURNS$
;    .T. if successful, otherwise .F.
; $DESCRIPTION$
;   This function is to purge those files that a workstation has
;   previously deleted.  This function only works on a Novell network.
; $EXAMPLES$
;   ERASE FILE foo.bar
;   ERASE FILE foo2.bar
;   ERASE FILE foo3.bar
;   ? FT_NOVPURGE()
; $END$



                include         minter.mac
extrn           __RETL:FAR
.MODEL	large, PASCAL
.data
req_buf		dw	1
subfun		db	16
rep_buf		dw	?
.CODE
FT_NOVPURG         PROC    FAR

@SAVE  	ds,es,si,di

start:		mov	ax, @data
		mov	ds, ax
		mov	es, ax
		mov	si,OFFSET req_buf
		mov	di,OFFSET rep_buf

;; ***   set up the registers
		mov	ah,226
		mov	al,0

		int	21h

;; ***   copy to the return variable


@RESTORE	ds,es,si,di
                
                cmp     al,0
                je      purgeok
                mov     ax,0
                jmp     purgeret
purgeok:        mov     ax,1
purgeret:	push	ax
		call	__RETL
		add	sp,2
                ret
FT_NOVPURG          ENDP
                END
